import	numpy as np # Imports	
import	torch
from matplotlib import pyplot as plt

X = np.random.rand(30, 1)*2.0 #	Create	data as numpy arrays
w = np.random.rand(2, 1) # Randomly select weights
y = (X*w[0] + w[1]/(X+1)**2) + np.random.randn(30, 1) * 0.05#	Create	targets
print('target w1 {} w2 {}'.format(w[0],	w[1]))
Xt = torch.from_numpy(X).float() # Convert numpy arrays	to torch tensors	
yt = torch.from_numpy(y).float()
W1 = torch.rand(1, requires_grad=True) # Initialize weights randomly with parameter requires_grad=True	
W2 = torch.rand(1, requires_grad=True)
lr = 0.005 # set up learning rate
for epoch in range(3500):
    y_pred = torch.add(torch.mul(W1,Xt), torch.div(W2, torch.add(Xt,torch.tensor(1))**2)) # create model
    loss = torch.mean((y_pred - yt) ** 2) # Compute cost function	
    loss.backward() # Run back-propagation
    W1.data = W1.data - lr*W1.grad.data # Update parameters	
    W2.data = W2.data - lr*W2.grad.data
    W1.grad.data.zero_() # Reset gradients	
    W2.grad.data.zero_()
print('found w1 {} w2 {}'.format(W1.data ,W2.data))

# visualisation
X_lin = np.linspace(0,2,100) 
plt.scatter(X,y) # plot measurements
plt.plot(X_lin,X_lin*w[0] + w[1]/(X_lin+1)**2,'r') # plot original function red
plt.plot(X_lin,X_lin*W1.detach().numpy() + W2.detach().numpy()/(X_lin+1)**2,'g') # plot function with estimated parameters
plt.show()

